import router from './router'
import store from './store'
import { Message } from 'element-ui'
import NProgress from 'nprogress'
import 'nprogress/nprogress.css'
import { getToken, getCompanyId } from '@/utils/auth'
import { isRelogin, getButtonLish } from '@/utils/request'
import { authApi } from '@/api/apis/auth'
import { getInfo } from '@/utils/auth'

NProgress.configure({
  showSpinner: false
})

const whiteList = [
  '/login',
  '/test',
  '/auth-redirect',
  '/bind',
  '/contractAssistant',
  '/register',
  '/systemInit',
  '/databaseLogin',
  '/apiLogs'

]

router.beforeEach((to, from, next) => {
  NProgress.start()
  if (getToken()) {
    to.meta.title && store.dispatch('settings/setTitle', to.meta.title)
    /* has token*/
    if (to.path === '/login') {
      next({
        path: '/'
      })
      NProgress.done()
    } else {
      let routeList = localStorage.getItem('routeList')
        ? localStorage.getItem('routeList')
        : null
      // store.dispatch("GenerateRoutes").then((accessRoutes) => {
      //  next()
      // })
      if (store.getters.permission_routes.length == 0) {

        store.dispatch('GenerateRoutes').then((accessRoutes) => {
          // 根据roles权限生成可访问的路由表
          // for (let i = 0, length = accessRoutes.length; i < length; i += 1) {
          //   const element = accessRoutes[i];
          //   // router.addRoutes(accessRoutes); // 动态添加可访问路由表
          // }
          router.addRoutes(accessRoutes) // 动态添加可访问路由表

          // router.addRoutes(accessRoutes) // 动态添加可访问路由表
          localStorage.setItem('routeList', JSON.stringify(accessRoutes))
          //获取当前已获取的权限按钮
          let perObj = store.getters.getButtonPre
          //获取当前权限按钮
          if (to.meta.id && !perObj[to.meta.id]) {
            let userId = JSON.parse(getInfo()).id
            authApi('sysButtonConfigService', '', 'getUserButton', '', {
              menuId: to.meta.id,
              userId: userId
            }).then((res) => {
              // 处理接口 格式为：{路由id:[按钮id,按钮id],....}
              let tempObj = {}
              let tempArr = []
              res.attribute.forEach((item) => {
                tempArr.push(item.nameEn)
              })
              tempObj.id = to.meta.id
              tempObj.value = tempArr
              store.commit('perButton/SET_BUTTONOBJ', tempObj)
              next({
                ...to,
                replace: true
              })
            })
          } else {
            next({
              ...to,
              replace: true
            })
          }
          // next({
          //   ...to,
          //   replace: true
          // }) // hack方法 确保addRoutes已完成
        })
      } else {
        //获取当前已获取的权限按钮
        let perObj = store.getters.getButtonPre
        if (to.meta.id && !perObj[to.meta.id]) {
          let userId = JSON.parse(getInfo()).id
          authApi('sysButtonConfigService', '', 'getUserButton', '', {
            menuId: to.meta.id,
            userId: userId
          }).then((res) => {
            // 处理接口 格式为：{路由id:[按钮id,按钮id],....}
            let tempObj = {}
            let tempArr = []
            res.attribute.forEach((item) => {
              tempArr.push(item.nameEn)
            })
            tempObj.id = to.meta.id
            tempObj.value = tempArr
            store.commit('perButton/SET_BUTTONOBJ', tempObj)
            next()
          })
        } else {
          next()
        }
      }
    }
  } else {
    // 没有token
    if (whiteList.indexOf(to.path) !== -1) {
      // 在免登录白名单，直接进入
      next()
    } else {
      next(`/login?redirect=${to.fullPath}`) // 否则全部重定向到登录页
      NProgress.done()
    }
  }
})

router.afterEach(() => {
  NProgress.done()
})
